.\"	$NetBSD: hp.4,v 1.12 2003/08/07 10:31:11 agc Exp $
.\"
.\" Copyright (c) 1991, 1993, 19801988
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	from: @(#)hp.4	8.1 (Berkeley) 6/5/93
.\"
.Dd June 5, 1993
.Dt HP 4 vax
.Os
.Sh NAME
.Nm hp
.Nd
.Tn MASSBUS
disk interface
.Sh SYNOPSIS
.Cd "hp0 at mba0 drive 0"
.Cd "hp* at mba? drive ?"
.Sh DESCRIPTION
The
.Nm hp
driver
is a generic MASSBUS disk driver which handles the standard
.Tn DEC
controllers.
It is typical of a block-device disk driver; block
.Tn I/O
is
described in
.Xr physio 4 .
.Pp
The script
.Xr MAKEDEV 8
should be used to create the special files; if a special file
needs to be created by hand consult
.Xr mknod 8 .
It is recommended as a security precaution to not create special files
for devices which may never be installed.
.Pp
The first sector of each disk contains both a first-stage bootstrap program
and a disk label containing geometry information and partition layouts (see
.Xr disklabel 5 .
This sector is normally write-protected, and disk-to-disk copies should
avoid copying this sector.
The label may be updated with
.Xr disklabel 8 ,
which can also be used to write-enable and write-disable the sector.
The next 15 sectors contain a second-stage bootstrap program.
.Sh DISK SUPPORT
During autoconfiguration or whenever a drive comes on line for the first time,
or when a drive is opened after all partitions are closed,
the first sector of the drive is examined for a disk label.
If a label is found, the geometry of the drive and the partition tables
are taken from it.
If no label is found, a fake label is created by the driver, enough
so that a real label can be written.
.Pp
The hp?a partition is normally used for the root file system,
the hp?b partition as a paging area,
and the hp?c partition for pack-pack copying (it maps the entire disk).
On disks larger than about 205 Megabytes, the hp?h partition
is inserted prior to the hp?d or hp?g partition;
the hp?g partition then maps the remainder of the pack.
.Sh FILES
.Bl -tag -width /dev/rhp[0-7][a-h] -compact
.It Pa /dev/hp[0-7][a-h]
block files
.It Pa /dev/rhp[0-7][a-h]
raw files
.El
.Sh DIAGNOSTICS
.Bl -diag
.It "hp%d%c: hard error %sing fsbn %d [of %d-%d] (hp%d bn %d cn %d tn %d sn %d) mbsr=%b er1=%b er2=%b."
An unrecoverable error occurred during transfer of the specified
filesystem block number,
which is a logical block number on the indicated partition.
If the transfer involved multiple blocks, the block range is printed as well.
The parenthesized fields list the actual disk sector number
relative to the beginning of the drive,
as well as the cylinder, track and sector number of the block.
The
.Tn MASSBUS
status register is printed in hexadecimal and
with the error bits decoded if any error bits other than
.Tn MBEXC
and
.Tn DTABT
are set.  In any case the contents of the two error registers are also printed
in octal and symbolically with bits decoded.
(Note that er2 is what old
.Tn RP06
manuals would call
.Tn RPER3 ;
the terminology
is that of the
.Tn RM
disks).
The error was either unrecoverable, or a large number of retry attempts
(including offset positioning and drive recalibration) could not
recover the error.
.Pp
.It "hp%d%c: soft ecc reading fsbn %d [of %d-%d] (hp%d bn %d cn %d tn %d sn %d)."
A recoverable
.Tn ECC
error occurred on the
specified sector of the specified disk partition.
If the transfer involved multiple blocks, the block range is printed as well.
The parenthesized fields list the actual disk sector number
relative to the beginning of the drive,
as well as the cylinder, track and sector number of the block.
This happens normally
a few times a week.  If it happens more frequently than
this the sectors where the errors are occurring should be checked to see
if certain cylinders on the pack, spots on the carriage of the drive
or heads are indicated.
.Pp
.El
.Sh SEE ALSO
.Xr physio 4 ,
.Xr up 4 ,
.Xr disklabel 5 ,
.Xr MAKEDEV 8 ,
.Xr disklabel 8 ,
.Xr mknod 8
.Sh HISTORY
The
.Nm
driver appeared in
.Bx 4.0 .
.Pp
A new
.Nm
driver showed up in
.Nx 1.2 .
.Sh BUGS
.Tn DEC Ns -standard
.Xr bad144 8
bad-block handling should be used.
.Pp
.Tn DEC Ns -standard
error logging should be supported.
.Pp
A program to analyze the logged error information (even in its
present reduced form) is needed.
